//--redFrik 20140121

//related RedWrite

RedRead {
	classvar >path= "/tmp/redringbuffer";
	classvar bufferSize= 10;
	classvar allSkip;
	var skip;
	*initClass {
		allSkip= List.new;
	}
	*stopAll {
		allSkip.do{|x| x.stop};
		allSkip= List.new;
	}
	*new {|name= "", post= true, updateRate= 0.01|
		^super.new.initRedRead(name, post, updateRate);
	}
	initRedRead {|name, post, updateRate|
		var task, pathname= path++name, index= 0;
		while({File.exists(pathname++index)}, {index= index+1});
		task= {
			var file, next, res;
			next= pathname++index;
			inf.do{
				while({File.exists(next)}, {
					file= File(next, "r");
					res= file.readAllString.interpret;
					file.close;
					if(post, {res.postln});
					index= index+1%bufferSize;
					next= pathname++index;
				});
				updateRate.wait;
			};
		};
		skip= SkipJack(task, updateRate, clock:SystemClock);
		allSkip.add(skip);
	}
	stopReading {|name|
		skip.stop;
		allSkip.remove(skip);
	}
}
